[{
  Name: 'Security System Monitor',
  Author: 'MaxFlax',
  Version: '1.0 150819',

  IconImage: 'pages/control/widgets/securityextended/generic/images/securitypanel.png',
  Initialized: false,

  RenderView: function (cuid, module) {
    var container = $(cuid);
    var widget = container.find('[data-ui-field=widget]');
    var _this = this;
    var virtualDomain = 'HomeGenie.SecuritySystem';
    if (!this.Initialized)
    {
      this.Initialized = true;
      // store a reference to ui fields
      this.nameText = widget.find('[data-ui-field=name]');
      this.descriptionText = widget.find('[data-ui-field=description]');
      this.statusText = widget.find('[data-ui-field=status]');
      this.iconImageIntruder = widget.find('[data-ui-field=intruderIcon]');
      this.iconImageFire = widget.find('[data-ui-field=fireIcon]');
      this.updateTime = widget.find('[data-ui-field=updatetime]');      
    }
    // render widget
    this.nameText.html(module.Name);
    this.descriptionText.html('');
    this.updateTime.html('');
    
    var intruderModule = HG.WebApp.Utility.GetModuleByDomainAddress(virtualDomain, 'Intruder');
    var fireModule = HG.WebApp.Utility.GetModuleByDomainAddress(virtualDomain, 'Fire');
    var intruderLevel = HG.WebApp.Utility.GetModulePropertyByName(intruderModule, "Security.Level");
    var fireLevel = HG.WebApp.Utility.GetModulePropertyByName(fireModule, "Security.Level");
    
    var intruderLevelCode = intruderLevel != null ? intruderLevel.Value : "0";
    var fireLevelCode = fireLevel != null ? fireLevel.Value : "0";
    var imageIntruderSrc = String.Empty;
    var imageFireSrc = String.Empty;
    
    switch (intruderLevelCode){
      case '0':
		imageIntruderSrc = "grey24.png";
        break;
      case '1':
        imageIntruderSrc = "blue24.png";
        break;
      case '2':
        imageIntruderSrc = "green24.png";
        break;
    }
    
    if (fireLevelCode == "1") {
		imageFireSrc = "green24.png";
    } else {
   		imageFireSrc = "grey24.png";
    }
    
    this.statusText.html(intruderLevelCode);
    
    this.iconImageIntruder.attr('src', 'pages/control/widgets/securityextended/generic/images/' + imageIntruderSrc);
    this.iconImageFire.attr('src', 'pages/control/widgets/securityextended/generic/images/' + imageFireSrc);
  }
}]