[{
    Name: "Security Alarm Fire",
    Author: "MaxFlax",
    Version: "1.0 150819",

	IconImage : 'pages/control/widgets/securityextended/generic/images/fire2.png',
	StatusText : '',
	Description : '',

    RenderView: function (cuid, module) {
		var container = $(cuid);
		var widget = container.find('[data-ui-field=widget]');
		var _this = this;

        if (!this.Initialized)
        {
            this.Initialized = true;
            this.nameText = widget.find('[data-ui-field=name]');
          	this.iconImage = widget.find('[data-ui-field=icon]');
          	this.statusText = widget.find('[data-ui-field=status]');
          	this.descriptionText = widget.find('[data-ui-field=description]');
          	this.disarmButton = widget.find('[data-ui-field=disarm]');
          	this.armButton = widget.find('[data-ui-field=arm]');

			widget.find('[data-ui-field=disarm]').on('click', function(){
				HG.Control.Modules.ServiceCall("Security.Fire.Disarm", module.Domain, module.Address, '', function (data) { });
			});

			widget.find('[data-ui-field=arm]').on('click', function(){
				HG.Control.Modules.ServiceCall("Security.Fire.Arm", module.Domain, module.Address, '', function (data) { });
			});
        }

		// read some context data
		this.GroupName = container.attr('data-context-group');
		var alarmStatus = HG.WebApp.Utility.GetModulePropertyByName(module, "HomeGenie.SecurityTriggered");
        var alarmStatusCode = alarmStatus.Value != "" ? alarmStatus.Value : "-1";

        switch (alarmStatusCode)
        {
			case "-1":
            	this.StatusText = "N/A";
            	break;
			case "0":
                this.StatusText = "OK";
                break;
            case "1":
                this.StatusText = "FIRE ALARM!";
                break;
        }

		var securityDescription = HG.WebApp.Utility.GetModulePropertyByName(module, "Security.Description");

		if (securityDescription != null && securityDescription.Value != null && securityDescription.Value != "")
		{
       		this.Description = securityDescription.Value;
		}
		else
		{
		    this.Description = "ERROR";
		}

		var securityLevel = HG.WebApp.Utility.GetModulePropertyByName(module, "Security.Level");
        var securityLevelCode = securityLevel.Value != "" ? securityLevel.Value : '0';

        var styleSelected = 'color:#3366FF;';
        var styleNotSelected = 'color:#ffffff;';
		var securityIcon = "fire2grey.png";
        var styleDisarm = styleSelected;
        var styleArm = styleNotSelected;
        
      	if (securityLevel.Value == "1")
        {
			styleDisarm = styleNotSelected;
			styleArm = styleSelected;
			securityIcon = "fire2.png";  
        }
        
		// render widget
		this.nameText.html(module.Name);
      	this.iconImage.attr('src', 'pages/control/widgets/securityextended/generic/images/' + securityIcon)
		this.statusText.html('<span style="vertical-align:middle">' + this.StatusText + '</span>');
        this.descriptionText.html(this.Description);

		this.disarmButton.attr('style', styleDisarm);
      	this.armButton.attr('style', styleArm);
	    }
}]