[{
    Name: "Security Alarm Intruder",
    Author: "MaxFlax",
    Version: "1.0 150819",
	
	IconImage: 'pages/control/widgets/securityextended/generic/images/unlock_red.png',
	StatusText: '',
	Description: '',    
  	Initialized: false,

    RenderView: function (cuid, module) {
		var container = $(cuid);
		var widget = container.find('[data-ui-field=widget]');
		var _this = this;
      
        if (!this.Initialized)
        {
            this.Initialized = true;
            this.nameText = widget.find('[data-ui-field=name]');
          	this.iconImage = widget.find('[data-ui-field=icon]');
          	this.statusText = widget.find('[data-ui-field=status]');
          	this.descriptionText = widget.find('[data-ui-field=description]');
          	this.disarmButton = widget.find('[data-ui-field=disarm]');
          	this.armHomeButton = widget.find('[data-ui-field=home]');
          	this.armAwayButton = widget.find('[data-ui-field=away]');
          
			widget.find('[data-ui-field=disarm]').on('click', function(){
				HG.Control.Modules.ServiceCall("Security.Intruder.Disarm", module.Domain, module.Address, '', function (data) { });
			});
			
			widget.find('[data-ui-field=home]').on('click', function(){
				HG.Control.Modules.ServiceCall("Security.Intruder.Home", module.Domain, module.Address, '', function (data) { });
			});
			
			widget.find('[data-ui-field=away]').on('click', function(){
				HG.Control.Modules.ServiceCall("Security.Intruder.Away", module.Domain, module.Address, '', function (data) { });
			});            
        }
                
		// read some context data        
		this.GroupName = container.attr('data-context-group');		
      	var alarmStatus = HG.WebApp.Utility.GetModulePropertyByName(module, "HomeGenie.SecurityTriggered");
        var alarmStatusCode = alarmStatus.Value != "" ? alarmStatus.Value : "-1";
              
        switch (alarmStatusCode)
        {
          	case "-1":
            	this.StatusText = "N/A";
            	break;
            case "0":
                this.StatusText = "OK";
                break;
            case "1":
                this.StatusText = "INTRUDER ALARM!";
                break;            
        }
        		
		var securityDescription = HG.WebApp.Utility.GetModulePropertyByName(module, "Security.Description");

		if (securityDescription != null && securityDescription.Value != null && securityDescription.Value != "")
		{
       		this.Description = securityDescription.Value;
		}
		else
		{
		    this.Description = "ERROR";
		}
		
		var intruderLevel = HG.WebApp.Utility.GetModulePropertyByName(module, "Security.Level");
        var intruderLevelCode = intruderLevel != null ? intruderLevel.Value : "0";

        var styleSelected = 'color:#3366FF;';
        var styleNotSelected = 'color:#ffffff;';
        
        var styleDisarm = styleSelected;
        var styleArmHome = styleNotSelected;
        var styleArmAway = styleNotSelected;
      	var securityIcon = "unlock_yellow.png";
        
        switch (intruderLevelCode)
        {
            case '1':
                styleDisarm = styleNotSelected;
                styleArmHome = styleSelected;
                styleArmAway = styleNotSelected;
            	securityIcon = "lock_blue.png";
                break;
            case '2':
                styleDisarm = styleNotSelected;
                styleArmHome = styleNotSelected;
                styleArmAway = styleSelected;
            	securityIcon = "lock_green.png";
                break;                            
        }
        
		// render widget
      	this.nameText.html(module.Name);
      	this.iconImage.attr('src', 'pages/control/widgets/securityextended/generic/images/' + securityIcon)
		this.statusText.html('<span style="vertical-align:middle">' + this.StatusText + '</span>');
        this.descriptionText.html(this.Description);
		this.disarmButton.attr('style', styleDisarm);
      	this.armHomeButton.attr('style', styleArmHome);
      	this.armAwayButton.attr('style', styleArmAway);      
	}
}]